.\" @(#)mailp.man 1.4 92/02/17
.TH MAILP 1 "17 February 1992"
.SH NAME
mailp \- frontend to the mp PostScript pretty printer
.SH SYNOPSIS
.BR mailp " [ options] file ..."
.PP
.BR newsp " [ options] file ..."
.PP
.BR digestp " [ options] file ..."
.PP
.BR filep " [ options] file ..."
.PP
.BR filofaxp " [ options] file ..."
.PP
.BR franklinp " [ options] file ..."
.PP
.BR timemanp " [ options] file ..."
.PP
.BR timesysp " [ options] file ..."
.SH DESCRIPTION
.I mailp
is a frontend to the
.I mp
PostScript pretty printer program. It uses different names to provide various
.I mp
options:
.PP
.I mailp
will print out mail messages.
.PP
.I newsp
will print out USENET news articles.
.PP
.I digestp
will print out USENET digest files.
.PP
.I filep
will print out ordinary ASCII files.
.PP
.I filofaxp
will print out in Filofax personal organiser format.
.PP
.I franklinp
will print out in Franklin Planner personal organiser format.
.PP
.I timemanp
will print out in Time Manager personal organiser format.
.PP
.I timesysp
will print out in Time/System International personal organiser format.
.PP
.I mailp
(and the associated programs) read each
.I filename
in sequence
and generate a prettified version of the contents in PostScript format. If no
filename arguments are provided,
.I mailp
reads the standard input.
.PP
.I mailp
uses the
.B PRINTER
environment variable to determine which
printer the output from the
.I mp
program is sent to. If this environment variable is not found, then it
defaults to the
.I ps
printer.
.SH OPTIONS
.TP
.B \-F
Instead of printing who the mail article is for, the top header will
contain who the mail article is from. A useful option for people with
their own personal printer.
.TP
.BI \-P printer
Send output to the named printer. Otherwise send output to the printer named
in the PRINTER environment variable.
.TP
.B \-h
Banner printing is disabled. Most of the information that typically appears
on the banner sheet is output in the \fImp\fR banners.
.TP
.BI \-d printer
Send output to the named printer. Otherwise send output to the printer named
in the PRINTER environment variable.
.TP
.B \-l
Format output in landscape mode.
Two pages of text will be printed per sheet of paper.
.TP
.BI \-s " subject"
Use
.I " subject"
as the new subject for the printout. If you are printing ordinary ASCII
files which have been specified on the command line, the subject will
default to the name of each of these files.
.SH "SEE ALSO"
.BR mp (1)
.SH AUTHORS
Original version by Bruno Pillard - October 1988.
.PP
Modified by Rich Burridge - June 1989 and October 1990.
.PP
Revisted by Larry W. Virden - August, September 1990.
.PP
Revisited by Bruno Pillard - September 1990.
.PP
Revisited by David W. Sanderson - August 1991.
